
//import 开始
document.write("<script src='../../sdks/utils.js'></script>");
document.write("<script src='../../sdks/base64.js'></script>");
document.write("<script src='../../sdks/events/Event.js'></script>");
document.write("<script src='../../sdks/core.js'></script>");
document.write("<script src='../../sdks/View.js'></script>");
document.write("<script src='../../sdks/TextView.js'></script>");
document.write("<script src='../../sdks/Button.js'></script>");
document.write("<script src='../../sdks/EditText.js'></script>");
document.write("<script src='../../sdks/CheckBox.js'></script>");
document.write("<script src='../../sdks/ToggleButton.js'></script>");
//import 结束.

//日志
var log=function (){
  //return
  var arr=arguments
  var str=""
  for(var i=0;i<arr.length;i++){
    var obj=arr[i];
    str+=String(obj)+" "
  }
	console.log(str)
	 
}
//错误
var err=function (str){
	log("error:"+str)
}





/********************  常用方法   *********************/

/*<1>****************数据处理*************/

//将json 内容转换为对象
//这个方法对服务端返回的JSON又包含json字符串的问题进行了处理。
function getFromJSON(str){
    try{
      str=String(str)
      //str=str.replace(/\\\"/g,"\"");
      var reg=new RegExp("\"{","g");
      str=str.replace(reg,"{")
      var reg1=new RegExp("}\"","g");
      str=str.replace(reg1,"}")
      
      //log("getFromJSON:"+str)
      var obj=JSON.parse(str)
      return obj
    }catch(e){
      log("parseJSONErr:"+e,"=====>"+str)
      return null;
    }
}

function getFromJobJSON(str){
    try{
      str=String(str)
       var regjjj0=new RegExp("\\u003c","g");
      str=str.replace(regjjj0,"<")
      var regjjj1=new RegExp("\\u003e","g");
      str=str.replace(regjjj1,">")
        var regjjj2=new RegExp("\\\\u003c","g");
      str=str.replace(regjjj2,"<")
      var regjjj3=new RegExp("\\\\u003e","g");
      str=str.replace(regjjj3,">")

      str=str.replace(/\\\"/g,"\"");
      var reg=new RegExp("\"{","g");
      str=str.replace(reg,"{")
      var reg1=new RegExp("}\"","g");
      str=str.replace(reg1,"}")

      var reghuanhang=new RegExp("\r\n","g");
      str=str.replace(reghuanhang,"\\n")

      
    str = str.replace(/&gt;/ig, "<");
                        //去掉HTML中的>
    str = str.replace(/&lt;/ig, ">");
        str = str.replace(/<br \/>|<br\/>|<br>/ig, "\\n");
                        //换掉<p></p>
    str = str.replace(/<p\/?[^>]*p>/g, "\\n");
                        //去掉f其他HTML Tag
    str = str.replace(/<\/?[^>]*>/g, "");
                        //去掉HTML空格
    str = str.replace(/&nbsp;/ig, " ");
                   
      
      log("getFromJSON:"+str)
      var obj=JSON.parse(str)
      return obj
    }catch(e){
      log("parseJSONErr:"+e,"=====>"+str)
      return null;
    }
}

//json 转 XML
function jsonToXml(o, tab) {
   var toXml = function(v, name, ind) {
      var xml = "";
      if (v instanceof Array) {
         for (var i=0, n=v.length; i<n; i++)
            xml += ind + toXml(v[i], name, ind+"\t") + "\n";
      }
      else if (typeof(v) == "object") {
         var hasChild = false;
         xml += ind + "<" + name;
         for (var m in v) {
            if (m.charAt(0) == "@")
               xml += " " + m.substr(1) + "=\"" + v[m].toString() + "\"";
            else
               hasChild = true;
         }
         xml += hasChild ? ">" : "/>";
         if (hasChild) {
            for (var m in v) {
               if (m == "#text")
                  xml += v[m];
               else if (m == "#cdata")
                  xml += "<![CDATA[" + v[m] + "]]>";
               else if (m.charAt(0) != "@")
                  xml += toXml(v[m], m, ind+"\t");
            }
            xml += (xml.charAt(xml.length-1)=="\n"?ind:"") + "</" + name + ">";
         }
      }
      else {
         xml += ind + "<" + name + ">" + v.toString() +  "</" + name + ">";
      }
      return xml;
   }, xml="";
   for (var m in o)
      xml += toXml(o[m], m, "");
   return tab ? xml.replace(/\t/g, tab) : xml.replace(/\t|\n/g, "");
}

//xml转JSON
function xmlToJson(xmlstr) {
   return xmlToJsonParser.parser(xmlstr)
};


/********* 原生 java 方法 反射*********/

//系统方法用户对java程序的控制
//执行java静态方法
function invokeStaticMethod(className,methodName,args,callback){
     args.splice(0,0,methodName)
	 args.splice(1,0,className)
	 sendToApp(generateId(),callback,"invokeStaticMethod",args);
}
//执行当前Activity的方法
function invokeActivityMethod(methodName,args,callback){
     args.splice(0,0,methodName)
	 sendToApp(generateId(),callback,"invokeActivityMethod",args);
}
//异步执行当前Activity的方法
function invokeActivityMethodAsyc(methodName,args,callback){
     args.splice(0,0,methodName)
     sendToApp(generateId(),callback,"invokeActivityMethodAsyc",args);
}
//执行java语句
//例如要执行 system.get(0).println("123"), methodStr=system.get().println()  methodParams=[[{type:"int",value:0},{type:"String",value:"123"}]]
//包名需要用#隔开 例如:com#wuba#bangbang#template#utils#javascript#JSUtils.test().tag.toString().length()
function executeNativeMethod(methodStr,methodParams,callback){
    sendToApp(generateId(),callback,"executeNativeMethod",[methodStr,methodParams]);
}
//获取一个java对象
function getJavaClass(){

}


/*********Activity 操作*********/
//打开一个Activity
//activity的类名,
//vo 的类名 如：com.wuba.job.model.vo
//voObject 要传递给activity的数据;
//onResult 对应activity的onresult回调.
function startActivity(activityClassName,voName,voObject,onResult,isBottomAnimation){
   var jsObject=new Object();
   jsObject.activityClassName=activityClassName;
   jsObject.voName=voName;
   jsObject.voObject=voObject;
   if(isBottomAnimation){
         jsObject.isBottomAnimation=true
   }
   sendToApp(generateId(),onResult,"startActivity",[jsObject])
}
//打开一个Activity 并向其Intent 传入key - value
function startActivityWithKV(activityClassName,key,value,onResult,isBottomAnimation){
   var jsObject=new Object();
   jsObject.activityClassName=activityClassName;
   jsObject.key=key;
   jsObject.value=value;
   if(isBottomAnimation){
      jsObject.isBottomAnimation=true
   }
   sendToApp(generateId(),onResult,"startActivity",[jsObject])
}
//打开一个Activity 并向其Intent 传入key - value
function startActivityWithKVArray(activityClassName,keyArr,valueArr,onResult,isBottomAnimation){
   var jsObject=new Object();
   jsObject.activityClassName=activityClassName;
   jsObject.keyArr=keyArr;
   jsObject.valueArr=valueArr;
   if(isBottomAnimation){
         jsObject.isBottomAnimation=true
   }
   sendToApp(generateId(),onResult,"startActivity",[jsObject])
}
//设置Activity标题
function setActivityTitle(str){
	invokeActivityMethod("setTitle",[{type:"String",value:str}],null)
}
//获取当前activity 对应的intent 里面的数据
function getIntentSerializableExtra(key,callback){
   sendToApp(generateId(),callback,"getIntentSerializableExtra",[key])
}
//设置activity的返回结果
function setResult(resultCode,key,value){
   invokeActivityMethod("setResult",[{type:"int",value:resultCode},{type:"String",value:key},{type:"String",value:value}],null)
}
//关闭当前Activity
function finishActivity(){
	invokeActivityMethod("finishActivity",[],null)
}
//设置当前Activity返回按键监听
function setBackButtonClickListener(callback){
	sendKeepListenerRequestToApp(generateId(),callback,"setBackButtonClickListener",[])
}


/**********原生组件***********/

//显示alert
//style 可以是 info confirm alert
function showAlert(str,style){
	if(!style){
		style="alert"
	}
	sendToApp(generateId(),null,"showAlert",[str,style])
}
//显示MessageBox
function showMessageBox(str,title,onSure,onCancel){
  showMessageBoxWithButtonStr(str,title,"","",onSure,onCancel)
}
//显示MessageBox
//str messagebox的内容
//title 标题
//sureBtnStr 确定按钮显示的文字 "" 表示默认“确定”
//cancelBtnStr 取消按钮显示的文字 "" 表示默认“取消”
//onSure  确定按钮点击后的回调函数
//onCancel 取消按钮点击后的回调函数
function showMessageBoxWithButtonStr(str,title,sureBtnStr,cancelBtnStr,onSure,onCancel){
   sendToApp(generateId(),onMsgBoxData,"showMessageBox",[str,title,sureBtnStr,cancelBtnStr])
   function onMsgBoxData(d){
      log("onMessageBoxData",d)
      if(d=="sure"){
        if(onSure){
          onSure()
        }
      }else{
        if(onCancel){
          onCancel()
        }
      }
   }
}
//显示只有一个按钮的MessageBox
//str 要显示的内容
//title 标题
//buttonStr 按钮的label
//onsure 点击的回调
function showMessageBoxOne(str,title,buttonStr,onSure){
   sendToApp(generateId(),onMsgBoxData,"showMessageBoxOne",[str,title,buttonStr])
   function onMsgBoxData(d){
      log("onMessageBoxData",d)
      if(onSure){
        onSure()
      }
   }
}
function showActionSheet(title,buttonArr,onClick){
     buttonArr.splice(0,0,title)
     sendToApp(generateId(),onClick,"showActionSheet",buttonArr)

}
//当前activity 显示加载进度
function showLoading(){
  invokeActivityMethod("setOnBusy",[{type:"boolean",value:true}],null);
}
function showLoadingWithString(tip) {
  invokeActivityMethod("setOnBusyWithString",[{type:"boolean",value:true},{type:"String",value:tip}],null);
}
function hideLoading(){
  invokeActivityMethod("setOnBusy",[{type:"boolean",value:false}],null);
}
//在某一个Activity 显示loading
function showActivityLoading(activityClassName){
  var exeStr=activityClassName.replace(/\./g, activityClassName)+".setOnBusy()"
  //com#wuba#bangbang#template#utils#javascript#JSUtils.test().tag.toString().length()
  executeNativeMethod(exeStr,[[{type:"boolean",value:true}]],null)
}
function hideActivityLoading(activityClassName){
  var exeStr=activityClassName.replace(/\./, activityClassName)+".setOnBusy()"
  //com#wuba#bangbang#template#utils#javascript#JSUtils.test().tag.toString().length()
  executeNativeMethod(exeStr,[[{type:"boolean",value:false}]],null)
}
//显示双滚轮
function showShuanggunlun(dataArr,callback){
     sendToApp(generateId(),callback,"showShuanggunlun",[dataArr])
}
//显示商圈双滚轮
function showCityShuangGunlun(cityId,callback){
     sendToApp(generateId(),callback,"showCityShuangGunlun",[cityId])
}

//显示单滚轮
function showDangunlun(dataArr,callback){
     sendToApp(generateId(),callback,"showDangunlun",[dataArr])
}




/*********数据 和 请求*********/
//post 
//url post的目标地址
//params 包含参数的Object 对象
//callback 返回数据时候的回调
function postData(url,params,callback){
    sendToApp(generateId(),callback,"postData",[url,params])
}
//使用get方式请求数据
function getData(url,callback){
	 sendToApp(generateId(),callback,"getData",[url])
}

function sendNotify(notifyEntity){
   sendToApp(generateId(),null,"sendNotify",["notify_js",notifyEntity])
}

/***************************/
//获取用户信息
function getUserInfo(callback){
	sendToApp(generateId(),callback,"getUserInfo",[])
}
//获取mac和Ip
function getMacAndIp(callback){
    sendToApp(generateId(),callback,"getMacAndIp",[])
}
//修复scrollview嵌套引起的 滑动事件屏蔽
function fixNestedScroll(parentId,childId){
    sendToApp(generateId(),null,"fixNestedScroll",[parentId,childId])
}
//设置图片上传组建的最大图片数量
function setMaxPicture(n){
  invokeActivityMethod("setMaxPicture",[{type:"int",value:n}],null)
}

//获取当前图片选取控件选择的图片
function getPictureData(callback){
   sendToApp(generateId(),callback,"getPictureData",[])
}
//获取当前图片选取控件选择的图片
function setPictureData(arr){
   var str=""
   for (var i = 0; i < arr.length; i++) {
      str+=arr[i]+"@wocale@"
   };
   if(str==""){
    return
   }
   sendToApp(generateId(),null,"setPictureData",[str])
}
//上传一组图片
function uploadPictures(picArr,callback){
   sendToApp(generateId(),callback,"uploadPictures",picArr)
}
//获取定位数据
function getLocation(callback){
   sendToApp(generateId(),callback,"getLocation",[])
}

//保存到本地
function saveToLocal(key,valueObj,callback){
  sendToApp(generateId(),callback,"saveToLocal",[key,valueObj])
}
//返回本地数据
function getFromLocal(key,callback){
    sendToApp(generateId(),function(d){
      callback(getFromJSON(d)||String(d))
    },"getFromLocal",[key])
}
//设置右上角按钮文字
function setRightBtnLabel(str){
   sendToApp(generateId(),null,"setRightLabel",[str])
}
//设置返回按钮文字
function setBackBtnLabel(str){
   sendToApp(generateId(),callback,"setBackLabel",[str])
}
//设置右上角按钮点击监听
function setRightButtonClickListener(callback){
   sendKeepListenerRequestToApp(generateId(),callback,"setRightButtonClickListener",[])
}
//日志上报
function reportLog(){
  var arr=arguments
  if(arr.constructor==String){
     var d=arr
     arr=[d]
  }
  var pArr=[]
  for (var i = 0; i < arr.length; i++) {
    pArr.push({type:"String",value:arr[i]})
  };
  invokeStaticMethod("com.wuba.bangjob.common.utils.log.Logger","trace",pArr,null)
}
//分享
//title 分享标题
//url 分享的网址
//pic 分享的图片
//text 分享的内容
function share(title,url,pic,text){
    var shareObj=new Object()
    shareObj.title=title
    shareObj.url=url
    shareObj.pic=pic
    shareObj.text=text
    var obj=new Object();
    obj.sessionId=new Date().getTime()+""+Math.floor(Math.random()*100000);
    obj.cmd="share"
    obj.args=[shareObj]
    //log("sending cmd to app:"+JSON.stringify(obj))
    if(window.app){
        window.app.executeCmd(JSON.stringify(obj))
    }   
}




